/*****************************************************************************
* Corpora                                                                    *
* Fetch requests for /corpora routes                                         *
*****************************************************************************/
Requests.corpora = {};

Requests.corpora.ent = {};

Requests.corpora.ent.delete = (corpusId) => {
  let input = `/corpora/${corpusId}`;
  let init = {
    method: 'DELETE'
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.build = (corpusId) => {
  let input = `/corpora/${corpusId}/build`;
  let init = {
    method: 'POST',
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.isPublic = {};

Requests.corpora.ent.isPublic.update = (corpusId, value) => {
  let input = `/corpora/${corpusId}/is_public`;
  let init = {
    method: 'PUT',
    body: JSON.stringify(value)
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.files = {};

Requests.corpora.ent.files.ent = {};

Requests.corpora.ent.files.ent.delete = (corpusId, corpusFileId) => {
  let input = `/corpora/${corpusId}/files/${corpusFileId}`;
  let init = {
    method: 'DELETE',
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.followers = {};

Requests.corpora.ent.followers.add = (corpusId, usernames) => {
  let input = `/corpora/${corpusId}/followers`;
  let init = {
    method: 'POST',
    body: JSON.stringify(usernames)
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.followers.ent = {};

Requests.corpora.ent.followers.ent.delete = (corpusId, followerId) => {
  let input = `/corpora/${corpusId}/followers/${followerId}`;
  let init = {
    method: 'DELETE',
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.ent.followers.ent.role = {};

Requests.corpora.ent.followers.ent.role.update = (corpusId, followerId, value) => {
  let input = `/corpora/${corpusId}/followers/${followerId}/role`;
  let init = {
    method: 'PUT',
    body: JSON.stringify(value)
  };
  return Requests.JSONfetch(input, init);
};
